/*  Form.java
 *  Copyright (c) 1999-2001, Dennis Groenendijk
 *  Copyright (c) 2002,2003, Brains2B.org
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.brains2b.swingext.form;

import javax.swing.JRootPane;

/** Interface for use with FormAction to handle
 *  the actions following pressing Ok/Apply/Undo/Cancel 
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [Jul 6, 2007]
 * @see FormAction
 */
public interface Form {
	/**
     * method called if Apply is pressed 
	 */
    public void performApply();
    
    /**
     * method called if Ok is pressed 
     */
	public void performOk();
    
    /**
     * method called if Undo is pressed
     *
     */
	public void performUndo();
    
    /**
     * method called if Cancel is pressed 
     */
	public void performCancel();
	
    /**
     * get the RootPane of the component this
     * interface is implemented on.
     * <p>needed for setting the default Button</p> 
     * @return JRootPane
     */
	public JRootPane getRootPane();
}

