/* 	ExtInputMapTest.java
 *	Copyright (c) 2007, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Jul 6, 2007
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.swingext.action;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JPanel;
import javax.swing.KeyStroke;

import junit.framework.TestCase;

import org.brains2b.swingext.action.ExtInputMap;

public class ExtInputMapTest extends TestCase {

    class ActionPanel extends JPanel implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            m_lastSource = e.getSource();
            m_lastCommand = e.getActionCommand();
        }
        
        public void processKeyEvent(KeyEvent e) {
            super.processKeyEvent(e);
        }
    }
    
    private Object m_lastSource;
    private String m_lastCommand;
    private ActionPanel m_panel = new ActionPanel();
    
    public void testMap() {
        ExtInputMap map =new ExtInputMap(m_panel);
        map.put(KeyStroke.getKeyStroke(KeyEvent.VK_F1, 0),
                "Pressed.F1");
        map.put(KeyStroke.getKeyStroke(KeyEvent.VK_F2, 0),
                "Pressed.F2");
        assertEquals(map.size(), map.getActionMap().size());
        m_panel.setInputMap(ActionPanel.WHEN_FOCUSED, map);
        m_panel.setActionMap(map.getActionMap());
        
        KeyEvent ke = new KeyEvent(m_panel,KeyEvent.KEY_PRESSED,0L,0,KeyEvent.VK_F2,(char) 0);
        m_panel.processKeyEvent(ke);
        assertEquals(m_panel, m_lastSource);
        assertEquals("Pressed.F2", m_lastCommand);
    }
}
